package com.itchy.engines
{
	import com.itchy.data.ExtractArray;
	import com.itchy.utils.MathSupport;
	
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	
	public class Timeline_deprecated extends Sprite
	{
		private var _data:ExtractArray = new ExtractArray();
		private var _size:int = 600;
		private var _math:MathSupport = new MathSupport();
		private var _coords:Array = new Array();
		
		public function Timeline_deprecated():void
		{
			trace("Class Timeline Initialized");
		}
		
		public function createTimeline(array:Array):void
		{ 
			//
			drawTimeline(array);
		}
		
		private function drawTimeline(array:Array):void
		{	
			var timeline:Sprite = new Sprite;
			addChild(timeline);
			drawLine();
			drawCircles();
			drawLabels(array);
			
			function drawLine():void
			{
				//Draw a diagonal timeline
				var line:Shape = new Shape();
				var g:Graphics = line.graphics;
				g.lineStyle(3, 0xFFFFFF);
				g.moveTo(50, 600);
				g.lineTo(50 + _math.Pythagoras(_size), 600 - _math.Pythagoras(_size));
				timeline.addChild(line);
				
			}
			function drawCircles():void {
				getCoords();
				var circles:Sprite = new Sprite();
				timeline.addChild(circles);
				for (var i:int = 0; i < _coords.length; i++)
				{
					for (var row:String in array)
					{
					}
					var circle:Shape = new Shape()
					circle = createCircle(1,0xFFFFFF,0xFFFFFF,_coords[i].x,_coords[i].y)
					circles.addChild(circle);
				}
			}
			function drawLabels(array:Array):void
			{
				var labels:Sprite = new Sprite();
				timeline.addChild(labels);
				for (var i:int = 0; i < _coords.length; i++)
				{
					var x:Number = _coords[i].x
					var y:Number = _coords[i].y
					if (i !== 0 && array[i].title == array[i-1].title)
					{
						toLabel = array[i].role;
						//trace(i,array[i].role,array[i].title);
						roleLabel = new TextField();
						roleLabel = createLabel(x, y, toLabel);
						roleLabel.x = x - roleLabel.textWidth - 10;
						labels.addChild(roleLabel);
					}
					else
					{
						//trace(i,array[i].title,"FIRST");
						var toLabel:String = _data.getTitles(array)[i] + " (" + _data.getProductionYears(array)[i] + ")";
						var label:TextField = new TextField();
						label = createLabel(x, y, toLabel);
						
						toLabel = array[i].role
						var roleLabel:TextField = new TextField()
						roleLabel = createLabel(x, y, toLabel);
						roleLabel.x = x - roleLabel.textWidth - 10;
						labels.addChild(label);
						labels.addChild(roleLabel);
					}
				}
			}
			function getCoords():void
			{
				var count:int = _data.getTitlesUnique(array).length;
				//_coords = _math.getCoords(count, _size);
				_coords = _math.setCoords(array,_size,count);
				//trace(data.yearsBoundaries(array));
			}
			function createCircle(size:int, color:uint, fill:uint, x:int, y:int):Shape
			{
				var circle:Shape = new Shape();
				var g:Graphics = circle.graphics;
				g.lineStyle(size, color)
				g.beginFill(fill);
				g.drawCircle(x,y,4);
				g.endFill();
				return circle
			}
			function createLabel(x:int, y:int, label:String):TextField
			{
				var labelFormat:TextFormat = new TextFormat();
				labelFormat.font = "MyriadPro-regular";
				labelFormat.color = 0xFFFFFA;
				var text:TextField = new TextField();
				text.defaultTextFormat = labelFormat;
				text.antiAliasType = AntiAliasType.ADVANCED;
				//text.embedFonts = true;
				text.x = x + 5;
				text.y = y - 8 ;
				text.autoSize = TextFieldAutoSize.LEFT;
				text.text = label;
				//text.width = width;
				//text.height = height;
				return text
			}
		}

		

	}
}